// gtkfeed.h
// wraps feed stuff into GtkTreeModel interfaces

#ifndef GTK_FEED_H
#define GTK_FEED_H

#include "feed.h"
#include <gtk/gtktreemodel.h>

// Feed

#define GTK_TYPE_FEED_MODEL (gtk_feed_model_get_type ())
#define GTK_FEED_MODEL(obj) \
	(G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_TYPE_FEED_MODEL, GtkFeedModel))
#define GTK_IS_FEED_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_TYPE_FEED_MODEL))

struct GtkFeedModel
{
	GObject parent;
	enum Columns { TITLE_COL, DATE_COL, WEIGHT_COL, TOOLTIP_COL, TOTAL_COLS };
	Feed *feed;
	News *getNews (GtkTreeIter *iter);
};

struct GtkFeedModelClass
{
	GObjectClass parent_class;
};

GtkTreeModel *gtk_feed_model_new (Feed *feed);
GType gtk_feed_model_get_type (void) G_GNUC_CONST;

// Manager

#define GTK_TYPE_MANAGER_MODEL (gtk_manager_model_get_type ())
#define GTK_MANAGER_MODEL(obj) \
	(G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_TYPE_MANAGER_MODEL, GtkManagerModel))
#define GTK_IS_MANAGER_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_TYPE_MANAGER_MODEL))

struct ManagerListener;

struct GtkManagerModel
{
	GObject parent;
	enum Columns { TITLE_COL, TITLE_UNREAD_COL, WEIGHT_COL, COLOR_COL, ICON_COL, TOTAL_COLS };
	Manager *manager;
	Feed *getFeed (GtkTreeIter *iter);

	void notifyPos (int pos);
	void notifyAll();
	ManagerListener *listener;
};

struct GtkManagerModelClass
{
	GObjectClass parent_class;
};

GtkTreeModel *gtk_manager_model_new();
GType gtk_manager_model_get_type (void) G_GNUC_CONST;

#endif /*GTK_FEED_H*/

